import os
from ckanext.odsh.pdf_to_thumbnail.thumbnail import get_filepath_to_resource, update_last_resource_if_value_empty
from ckanext.odsh.lib.uploader import calculate_hash
import ckan.plugins.toolkit as toolkit

def save_hash_into_resource(context, resource):
    path = get_filepath_to_resource(resource)
    if os.path.exists(path):
        with open(path, 'rb') as file:
            hash = calculate_hash(file)
            package = update_last_resource_if_value_empty(context, resource, 'hash', hash)
        toolkit.get_action('package_update')(context, package)

    



